import { Component, Input, ElementRef, ContentChildren } from '@angular/core';
import { carousel, fade } from '../../animate/base';
import { ToolService } from '../../tool/tool.service';
var CarouselItemComponent = (function () {
    function CarouselItemComponent() {
        this.show = false;
    }
    CarouselItemComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngz-carousel-item',
                    template: "\n<div *ngIf=\"show\" class=\"full rel\" [@Carousel]=\"state\">        \n    <img draggable=\"false\" class=\"full\" [src]=\"src\">\n    <ng-content select=\".carousel-item-header\"></ng-content>\n</div>\n    ",
                    animations: [carousel()]
                },] },
    ];
    /** @nocollapse */
    CarouselItemComponent.ctorParameters = function () { return []; };
    CarouselItemComponent.propDecorators = {
        'src': [{ type: Input },],
    };
    return CarouselItemComponent;
}());
export { CarouselItemComponent };
var CarsouselComponent = (function () {
    function CarsouselComponent(tool, _el) {
        this.tool = tool;
        this._el = _el;
        this.cycle = true;
        this.height = 300;
        this.interval = 2000;
        this.items = [];
        var node = _el.nativeElement;
    }
    Object.defineProperty(CarsouselComponent.prototype, "_autoPlay", {
        set: function (val) {
            if (this.autoPlay = val)
                this.cycle = true;
        },
        enumerable: true,
        configurable: true
    });
    CarsouselComponent.prototype.leave = function () {
        this.isEdit = false;
        this.play();
    };
    CarsouselComponent.prototype.enter = function () {
        this.isEdit = true;
        this.pause();
    };
    CarsouselComponent.prototype.play = function () {
        var _this = this;
        if (this.autoPlay)
            this.playInterval = setInterval(function () { return _this.next(_this.autoPlay == 'right' ? 1 : -1); }, this.interval);
    };
    CarsouselComponent.prototype.pause = function () {
        if (this.autoPlay && this.playInterval) {
            clearInterval(this.playInterval);
            this.playInterval = null;
        }
    };
    CarsouselComponent.prototype.init = function () {
        this.nowIndex = 0;
        this.maxIndex = this.itemList.length - 1;
        var items = this.items = this.itemList._results;
        items[0].show = true;
        this.play();
    };
    CarsouselComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.init();
        this.itemList.changes.subscribe(function () { _this.init(); });
    };
    CarsouselComponent.prototype.carousel = function (num, nextIndex) {
        var nextItem = this.items[nextIndex], nowItem = this.items[this.nowIndex];
        if (num < 0) {
            nowItem.state = 'right';
            nextItem.state = 'left';
        }
        else {
            nowItem.state = 'left';
            nextItem.state = 'right';
        }
        setTimeout(function () { nowItem.show = false; nextItem.show = true; });
        this.nowIndex = nextIndex;
    };
    CarsouselComponent.prototype.selectItem = function (index) {
        var now = this.nowIndex;
        if (index == now)
            return;
        this.carousel(index > now ? 1 : -1, index);
    };
    CarsouselComponent.prototype.next = function (num) {
        var nextIndex = this.nowIndex + num;
        if (!this.cycle && (nextIndex > this.maxIndex || nextIndex < 0))
            return;
        nextIndex = nextIndex > this.maxIndex ? 0 : (nextIndex < 0 ? this.maxIndex : nextIndex);
        this.carousel(num, nextIndex);
    };
    CarsouselComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngz-carousel',
                    template: "\n<div (mouseenter)=\"enter()\" (mouseleave)=\"leave()\" class=\"carousel noSelect\" [style.height.px]=\"height\" style=\"overflow: hidden\">\n    <div [@Fade] *ngIf=\"isEdit\" [style.fontSize.px]=\"btnSize\" class=\"abs-tl-0 h-100 center\">\n        <span class=\"carousel-btn btn-left\" data-foo=\"<\" (click)=\"next(-1)\"></span>\n    </div>\n    <div ngz-handEvent (handLeft)=\"next(1)\" (handRight)=\"next(-1)\" class=\"full\">\n         <ng-content></ng-content>\n    </div>\n    <div [@Fade] *ngIf=\"isEdit\" [style.fontSize.px]=\"btnSize\" class=\"abs-tr-0 h-100 center\">\n        <span class=\"carousel-btn btn-right\" data-foo=\">\" (click)=\"next(1)\"></span>\n    </div>\n    <div class=\"carousel-nav\">\n        <span (click)=\"selectItem(index)\" [class.active]=\"index==nowIndex\" *ngFor=\"let i of items;index as index;\" class=\"carousel-nav-item\"></span>\n    </div>\n</div>",
                    animations: [fade()]
                },] },
    ];
    /** @nocollapse */
    CarsouselComponent.ctorParameters = function () { return [
        { type: ToolService, },
        { type: ElementRef, },
    ]; };
    CarsouselComponent.propDecorators = {
        'itemList': [{ type: ContentChildren, args: [CarouselItemComponent,] },],
        'cycle': [{ type: Input },],
        'height': [{ type: Input },],
        'btnSize': [{ type: Input },],
        '_autoPlay': [{ type: Input, args: ['autoPlay',] },],
        'interval': [{ type: Input },],
    };
    return CarsouselComponent;
}());
export { CarsouselComponent };
//# sourceMappingURL=carousel.component.js.map