import { Component, ContentChildren, Input } from '@angular/core';
import { CollapseItemComponent } from './collapseItem.component';
import { Subject } from 'rxjs/Subject';
var CollapseComponent = (function () {
    function CollapseComponent() {
        this._type = 'l';
        this.typeSub = new Subject();
        this.preIndex = null;
    }
    Object.defineProperty(CollapseComponent.prototype, "type", {
        set: function (val) {
            if (val !== undefined) {
                this._type = val;
                this.typeSub.next(val);
            }
        },
        enumerable: true,
        configurable: true
    });
    CollapseComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.initItem();
        this._items.changes.subscribe(function () { return _this.initItem(); });
    };
    CollapseComponent.prototype.initItem = function () {
        var _this = this;
        var _items = this._items._results;
        _items.forEach(function (control, index) {
            if (_this.noAnimate)
                control.state = 'stop';
            control.index = index;
            control.clearMark = function () { return _this.preIndex = null; };
            control.openParent = function (i) {
                if (_this.preIndex !== null) {
                    var preItem = _items.find(function (control) { return control.index == _this.preIndex; });
                    preItem.isOpen = false;
                }
                _this.preIndex = i;
            };
        });
    };
    CollapseComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngz-collapse',
                    template: "\n        <div>\n            <ng-content></ng-content>\n        </div>\n    ",
                    host: {
                        class: 'btn-group-block'
                    }
                },] },
    ];
    /** @nocollapse */
    CollapseComponent.ctorParameters = function () { return []; };
    CollapseComponent.propDecorators = {
        'type': [{ type: Input },],
        'noAnimate': [{ type: Input },],
        '_items': [{ type: ContentChildren, args: [CollapseItemComponent,] },],
    };
    return CollapseComponent;
}());
export { CollapseComponent };
//# sourceMappingURL=collapse.component.js.map