import { Directive, Input, Output, EventEmitter, ElementRef } from '@angular/core';
import { ToolService } from '../tool/tool.service';
var HandEventDirective = (function () {
    function HandEventDirective(tool, _el) {
        var _this = this;
        this.tool = tool;
        this._el = _el;
        this.listen = function () {
            _this.destroy = _this.tool.slideEvents(_this._el.nativeElement, _this.withDrag, function (states) {
                states.forEach(function (state) {
                    _this[state].emit();
                });
                _this.direction.emit(states);
            });
        };
        this.direction = new EventEmitter();
        this.up = new EventEmitter();
        this.down = new EventEmitter();
        this.left = new EventEmitter();
        this.right = new EventEmitter();
        this.listen();
    }
    HandEventDirective.prototype.ngOnDestroy = function () {
        this.destroy();
    };
    HandEventDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngz-handEvent]',
                    exportAs: 'ngz-handEvent'
                },] },
    ];
    /** @nocollapse */
    HandEventDirective.ctorParameters = function () { return [
        { type: ToolService, },
        { type: ElementRef, },
    ]; };
    HandEventDirective.propDecorators = {
        'withDrag': [{ type: Input },],
        'direction': [{ type: Output, args: ['direction',] },],
        'up': [{ type: Output, args: ['handUp',] },],
        'down': [{ type: Output, args: ['handDown',] },],
        'left': [{ type: Output, args: ['handLeft',] },],
        'right': [{ type: Output, args: ['handRight',] },],
    };
    return HandEventDirective;
}());
export { HandEventDirective };
//# sourceMappingURL=hand-event.directive.js.map