import { Component, Directive, ElementRef, TemplateRef, Input, Injector, ViewContainerRef, ComponentFactoryResolver, ChangeDetectionStrategy, ChangeDetectorRef } from '@angular/core';
import { PositionService } from '../../tool/pos.service';
import { ToolService } from '../../tool/tool.service';
import { Resize } from '../../service/resize.service';
import { menu } from '../../animate/base';
var MenuComponent = (function () {
    function MenuComponent(_cd, el, pos) {
        var _this = this;
        this._cd = _cd;
        this.pos = pos;
        this.state = 'hid';
        this.open = function (cb) {
            _this.state = 'show';
            _this._cd.markForCheck();
            _this.cb0 = cb;
        };
        this.close = function (cb) {
            _this.state = 'hid';
            _this._cd.markForCheck();
            _this.cb = cb;
        };
        this.done = function () { return _this.state == 'hid' ? _this.cb && _this.cb() : _this.cb0 && _this.cb0(); };
    }
    Object.defineProperty(MenuComponent.prototype, "placement", {
        set: function (val) {
            this._place = val;
            this.origin = this.pos._origin(val);
        },
        enumerable: true,
        configurable: true
    });
    MenuComponent.decorators = [
        { type: Component, args: [{
                    template: "\n        <div [style.transform-origin]=\"origin\" class=\"menu-content-{{_place}}\" [@Menu]=\"state\" (@Menu.done)=\"done()\">\n            <ng-content></ng-content>\n        </div>\n    ",
                    host: {
                        'class': 'abs menu'
                    },
                    animations: [menu()],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    MenuComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef, },
        { type: ElementRef, },
        { type: PositionService, },
    ]; };
    return MenuComponent;
}());
export { MenuComponent };
var MenuDirective = (function () {
    function MenuDirective(_vcr, _cfr, _injector, _el, pos, tool, _res) {
        var _this = this;
        this._vcr = _vcr;
        this._cfr = _cfr;
        this._injector = _injector;
        this._el = _el;
        this.pos = pos;
        this.tool = tool;
        this._res = _res;
        this.placement = 'bottom';
        this.body = document.querySelector('body');
        this.resOrder = this._res.valSub.subscribe(function () {
            _this.storeEl = null;
            _this.close(true);
        });
    }
    MenuDirective.prototype.close = function (force) {
        var _this = this;
        if (!force && this.prevent || !this.isOpen)
            return;
        this.prevent = true;
        this.comRef.instance.close(function () {
            if (_this.disCache || force) {
                _this.comRef.destroy();
                _this.storeEl = null;
            }
            else {
                _this.storeEl && _this.body.removeChild(_this.storeEl);
            }
            _this.isOpen = false;
            _this.prevent = false;
        });
    };
    MenuDirective.prototype.setPos = function () {
        var pos = this.pos.tooltipPos(this._el.nativeElement, this.storeEl, this.placement, false, 1);
        for (var i in pos.pos) {
            this.storeEl.style[i] = pos.pos[i];
        }
    };
    MenuDirective.prototype.open = function () {
        var _this = this;
        console.log(this.tp);
        if (this.prevent || !(this.tp instanceof TemplateRef))
            return;
        this.prevent = true;
        if (!this.storeEl) {
            this.viewRef && this._vcr.remove(this._vcr.indexOf(this.viewRef));
            this.viewRef = this._vcr.createEmbeddedView(this.tp);
            this.comRef = this._vcr.createComponent(this._cfr.resolveComponentFactory(MenuComponent), 0, this._injector, [this.viewRef.rootNodes]);
            this.storeEl = this.comRef.location.nativeElement;
            this.comRef.instance.placement = this.placement;
            this.setPos();
        }
        this.body.appendChild(this.storeEl);
        this.comRef.instance.open(function () {
            _this.isOpen = true;
            !_this.disDocument && setTimeout(function () { return _this.tool.listenOnce(document, 'click', function () { return _this.close(); }); });
            _this.prevent = false;
        });
    };
    MenuDirective.prototype.toggle = function () {
        this.isOpen ? this.close() : this.open();
    };
    MenuDirective.prototype.click = function () {
        this.isOpen ? this.disDocument && this.close() : this.open();
    };
    MenuDirective.prototype.ngOnDestroy = function () {
        this.comRef && this.comRef.destroy();
        this.resOrder.unsubscribe();
    };
    MenuDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngz-menu]',
                    host: {
                        '(click)': 'click()'
                    },
                    exportAs: 'ngz-menu'
                },] },
    ];
    /** @nocollapse */
    MenuDirective.ctorParameters = function () { return [
        { type: ViewContainerRef, },
        { type: ComponentFactoryResolver, },
        { type: Injector, },
        { type: ElementRef, },
        { type: PositionService, },
        { type: ToolService, },
        { type: Resize, },
    ]; };
    MenuDirective.propDecorators = {
        'placement': [{ type: Input },],
        'disCache': [{ type: Input },],
        'disDocument': [{ type: Input },],
        'tp': [{ type: Input, args: ['ngz-menu',] },],
    };
    return MenuDirective;
}());
export { MenuDirective };
//# sourceMappingURL=menu.component.js.map