import { Component, Input, ElementRef } from '@angular/core';
var ProgressBarComponent = (function () {
    function ProgressBarComponent(_el) {
        this._el = _el;
        this.type = 'p';
        this.max = 100;
        this.width = 10;
        this.preMax = this.max;
    }
    Object.defineProperty(ProgressBarComponent.prototype, "size", {
        set: function (val) {
            if (!val)
                return;
            this._el.nativeElement.classList.add('progress-' + val);
        },
        enumerable: true,
        configurable: true
    });
    ProgressBarComponent.prototype.ngOnChanges = function () {
        if (this.value !== undefined && this.max && (this.value != this.preValue || this.max != this.preMax)) {
            var max = this.max, val = this.value;
            this.width = Math.round(100 * val / max);
        }
    };
    ProgressBarComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngz-progress-bar',
                    template: "        \n            <div [style.width.%]=\"width\" [ngClass]=\"\n            ['bg-'+type,'progress-bar',stripe?'progress-strip':'',animate?'progress-bar-animate':'']\">\n                {{showValue?width+'%':''}}\n            </div>\n    ",
                    host: {
                        'class': 'progress-container'
                    }
                },] },
    ];
    /** @nocollapse */
    ProgressBarComponent.ctorParameters = function () { return [
        { type: ElementRef, },
    ]; };
    ProgressBarComponent.propDecorators = {
        'stripe': [{ type: Input },],
        'type': [{ type: Input },],
        'size': [{ type: Input },],
        'max': [{ type: Input },],
        'value': [{ type: Input },],
        'showValue': [{ type: Input },],
        'animate': [{ type: Input },],
    };
    return ProgressBarComponent;
}());
export { ProgressBarComponent };
//# sourceMappingURL=progress-bar.component.js.map