import { EventEmitter } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/throttleTime';
import 'rxjs/add/observable/fromEvent';
import 'rxjs/add/operator/debounceTime';
import { ScrollService } from '../../service/scroll.service';
export interface OffsetControl {
    top: number;
    bottom: number;
    value: any;
    over?: any;
}
export interface ScrollOpts {
    value?: string | number;
    duration?: number;
    vt?: number;
    notBottom?: boolean;
}
export interface ScrollOpts2 {
    value: number;
    notBottom?: boolean;
    duration?: number;
    vt?: number;
    top?: number;
    end?: number;
    timing?: 'out' | 'in' | null;
}
export declare class ScrollComponent {
    _scroll: ScrollService;
    constructor(_scroll: ScrollService);
    controls: any;
    baseLine: any;
    throttleTime: number;
    event: EventEmitter<any>;
    justScroll: boolean;
    forbidAnimate: boolean;
    scrollOb: Observable<any>;
    resizeOb: Observable<any>;
    offsetControls: Array<OffsetControl>;
    scrollSub: any;
    resizeSub: any;
    storeMsn: any;
    scrollTop: number;
    pause: boolean;
    bound: number;
    emit: any;
    changeEmit: any;
    subScroll(): void;
    ngAfterViewInit(): void;
    getScrollPos(): {
        top: number;
        bottom: number;
    };
    checkOnce(pos: any): void;
    calControls(refresh?: boolean): void;
    getControlOffset: (value: any) => OffsetControl;
    scrollToNode: (node: any, opts?: any) => Promise<{}>;
    scrollTo(opts: ScrollOpts): Promise<void> | Promise<{}>;
    scrollTo2(opts: ScrollOpts2 | any): Promise<{}>;
    destroy(): void;
    registerOnTouched(): void;
    registerOnChange(fn: any): void;
    writeValue(value: any): void;
    ngOnDestroy(): void;
}
