import { Directive, Input, ElementRef, Output, EventEmitter } from '@angular/core';
import { Parent } from './parent';
var ScrollBindDirective = (function () {
    function ScrollBindDirective(el, parent) {
        var _this = this;
        this.el = el;
        this.parent = parent;
        this.baseLine = 0;
        this.entry = new EventEmitter();
        this.scrollSelf = this.parent.event.map(function (event) {
            if (!_this.offsetSelf)
                _this.offsetSelf = _this.parent.getControlOffset(_this.value);
            return _this.over ? event.bottom : event.top;
        });
    }
    Object.defineProperty(ScrollBindDirective.prototype, "sticky", {
        set: function (val) {
            var _this = this;
            if (val === undefined)
                return;
            var node = this.el.nativeElement;
            var destrop = function () {
                node.style.position = null;
                node.style.top = null;
            };
            if (val == 'destroy') {
                destrop();
                return;
            }
            var parent = document.createElement('div');
            setTimeout(function () {
                node.parentNode.insertBefore(parent, node);
                parent.appendChild(node);
                var rect = node.getBoundingClientRect();
                parent.style.height = rect.height + 'px';
                if (!_this.stickySub) {
                    _this.stickySub = _this.scrollSelf.subscribe(function (v) {
                        var p = _this.parent.getControlOffset(_this.value);
                        if (_this.remainTop === undefined)
                            _this.remainTop = _this.offsetSelf.top;
                        if (v > _this.offsetSelf.top) {
                            node.style.position = 'fixed';
                            node.style.top = val;
                        }
                        else {
                            destrop();
                        }
                    });
                }
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollBindDirective.prototype, "useEntry", {
        set: function (v) {
            var _this = this;
            if (!v)
                return;
            var preValue, fn1 = function (value) {
                if (value == preValue)
                    return;
                preValue = value;
                _this.entry.emit(value);
            };
            this.entrySub = this.scrollSelf.subscribe(function (val) {
                if (val < _this.offsetSelf.top) {
                    fn1('up');
                }
                else if (val >= _this.offsetSelf.top && val <= _this.offsetSelf.bottom) {
                    fn1('in');
                }
                else {
                    fn1('down');
                }
            });
        },
        enumerable: true,
        configurable: true
    });
    ScrollBindDirective.prototype.ngOnDestroy = function () {
        this.stickySub && this.stickySub.unsubscribe();
        this.entrySub && this.entrySub.unsubscribe();
    };
    ScrollBindDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngz-scroll-item]'
                },] },
    ];
    /** @nocollapse */
    ScrollBindDirective.ctorParameters = function () { return [
        { type: ElementRef, },
        { type: Parent, },
    ]; };
    ScrollBindDirective.propDecorators = {
        'value': [{ type: Input, args: ['ngz-scroll-item',] },],
        'over': [{ type: Input },],
        'baseLine': [{ type: Input },],
        'entry': [{ type: Output, args: ['entry',] },],
        'sticky': [{ type: Input },],
        'useEntry': [{ type: Input, args: ['useEntry',] },],
    };
    return ScrollBindDirective;
}());
export { ScrollBindDirective };
//# sourceMappingURL=scrollBind.directive.js.map