import { Directive, TemplateRef, ViewContainerRef, Input } from '@angular/core';
import { Resize } from '../../service/resize.service';
var GridDirective = (function () {
    function GridDirective(_tp, _vcr, resize) {
        var _this = this;
        this._tp = _tp;
        this._vcr = _vcr;
        this.resize = resize;
        this.remove = function () {
            _this._vcr.clear();
            _this.viewRef = null;
        };
        this.add = function () { return !_this.viewRef && (_this.viewRef = _this._vcr.createEmbeddedView(_this._tp)); };
        var preval;
        this.resSub = resize.valSub.subscribe(function (val) {
            if (val != preval) {
                _this.setCol(val);
                preval = val;
            }
        });
    }
    Object.defineProperty(GridDirective.prototype, "colStg", {
        set: function (val) {
            if (!val)
                return;
            if (val[0] == '!') {
                this.deny = true;
                this.size = val.slice(1);
            }
            else {
                this.deny = false;
                this.size = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    GridDirective.prototype.ngOnInit = function () {
        this.setCol(this.resize.value);
    };
    GridDirective.prototype.setCol = function (val) {
        if (this.deny) {
            val != this.size ? this.add() : this.remove();
        }
        else {
            val == this.size ? this.add() : this.remove();
        }
    };
    ;
    GridDirective.prototype.ngOnDestroy = function () {
        this.resSub.unsubscribe();
    };
    GridDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngz-col-show]',
                    host: {
                        '(click)': 'click()'
                    }
                },] },
    ];
    /** @nocollapse */
    GridDirective.ctorParameters = function () { return [
        { type: TemplateRef, },
        { type: ViewContainerRef, },
        { type: Resize, },
    ]; };
    GridDirective.propDecorators = {
        'colStg': [{ type: Input, args: ['ngz-col-show',] },],
    };
    return GridDirective;
}());
export { GridDirective };
//# sourceMappingURL=grid.directive.js.map