import { Pipe } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
var TrustPipe = (function () {
    function TrustPipe(sanitizer) {
        this.sanitizer = sanitizer;
    }
    TrustPipe.prototype.transform = function (val, args) {
        args = args || 'Html';
        var method = 'bypassSecurityTrust' + args[0].toUpperCase() + args.slice(1);
        return this.sanitizer[method].call(this.sanitizer, val);
    };
    TrustPipe.decorators = [
        { type: Pipe, args: [{
                    name: 'ngzTrust'
                },] },
    ];
    /** @nocollapse */
    TrustPipe.ctorParameters = function () { return [
        { type: DomSanitizer, },
    ]; };
    return TrustPipe;
}());
export { TrustPipe };
//# sourceMappingURL=trust.pipe.js.map