import { Injectable } from '@angular/core';
import { PositionService } from '../tool/pos.service';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/throttleTime';
import 'rxjs/add/observable/fromEvent';
import 'rxjs/add/observable/merge';
var ScrollService = (function () {
    function ScrollService(pos) {
        var _this = this;
        this.pos = pos;
        this.getPos = function () {
            var top = _this.getScrollTop();
            return { top: top, bottom: top + window.innerHeight };
        };
        this.getScrollTop = function () { return window.pageYOffset; };
        this.getScrollEnd = function () { return document.querySelector('body').scrollHeight; };
        var scrollOb = Observable.fromEvent(window, 'scroll').map(function () { return _this.getPos(); });
        var tailerOb = scrollOb.debounceTime(150);
        var initOb = Observable.timer(1, 100).take(2).map(function () { return _this.getPos(); });
        this.scrollEvent = scrollOb.merge(tailerOb, initOb);
        var preH, nowH, body = document.querySelector('body');
        this.detectBodyHeight = Observable.interval(500).filter(function () {
            nowH = body.offsetHeight;
            if (nowH !== preH) {
                preH = nowH;
                return true;
            }
            return false;
        });
    }
    ScrollService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    ScrollService.ctorParameters = function () { return [
        { type: PositionService, },
    ]; };
    return ScrollService;
}());
export { ScrollService };
//# sourceMappingURL=scroll.service.js.map