var Debounce = (function () {
    function Debounce(t) {
        var _this = this;
        this.run = function (fn) {
            if (_this.timeout) {
                clearTimeout(_this.timeout);
            }
            _this.timeout = setTimeout(function () {
                fn();
                _this.timeout = null;
            }, t);
        };
    }
    return Debounce;
}());
export { Debounce };
export var debounce = function (cb, t) {
    if (t === void 0) { t = 1000; }
    var db = new Debounce(t);
    return function (e) {
        db.run(function () { return cb(e); });
    };
};
//# sourceMappingURL=debounce.js.map