import { Observable } from 'rxjs';
import 'rxjs/add/observable/fromEvent';
var baseDis = 80;
var moveEvent = function (node, begin, cb, end, withDrag, noDis) {
    node.classList.add('noSelect');
    var origin = {}, disX = 0, disY = 0, rect;
    var dis = function (e) {
        rect = node.getBoundingClientRect();
        disX = e.pageX - rect.left;
        disY = e.pageY - rect.top - window.pageYOffset;
    }, ori = function (e, start) {
        origin.x = Math.round(e.pageX - disX);
        origin.y = Math.round(e.pageY - disY);
        if (origin.x < 0 && origin.y < 0)
            return;
        return origin;
    }, startOri = function (e) {
        !noDis && dis(e);
        ori(e) && begin(origin);
    }, moveOri = function (e) { return ori(e) && cb(origin); };
    var subs = {}, clearSub = function (params) {
        params.forEach(function (sub) {
            if (!subs[sub])
                return;
            subs[sub].unsubscribe();
            subs[sub] = null;
        });
    };
    var touchStartOb = Observable.fromEvent(node, 'touchstart', false), touchMoveOb = Observable.fromEvent(node, 'touchmove'), touchEndOb = Observable.fromEvent(node, 'touchend');
    subs.touchStartSub = touchStartOb.subscribe(function (e) {
        startOri(e.targetTouches[0]);
        e.preventDefault();
    });
    subs.touchMoveSub = touchMoveOb.subscribe(function (e) {
        e.preventDefault();
        moveOri(e.targetTouches[0]);
    }),
        subs.touchEndSub = end && touchEndOb.subscribe(end);
    var mouseUpSub, mouseMoveSub;
    var mouseMoveOb = Observable.fromEvent(document, 'mousemove'), mouseUpOb = Observable.fromEvent(document, 'mouseup'), mouseDownOb = Observable.fromEvent(node, 'mousedown'), dragOb = Observable.fromEvent(document, 'drag'), dragEndOb = Observable.fromEvent(document, 'dragend');
    var i = 0;
    var clearMouseSub = function () { return clearSub(['mouseMoveSub', 'mouseUpSub', 'drag', 'dragEnd']); };
    subs.mouseDownSub = mouseDownOb.subscribe(function (e) {
        startOri(e);
        //restore anomaly:
        clearMouseSub();
        var cancel = function () {
            clearMouseSub();
            end && end();
        };
        if (withDrag) {
            subs.drag = dragOb.subscribe(moveOri);
            subs.dragEnd = dragEndOb.subscribe(cancel);
        }
        subs.mouseMoveSub = mouseMoveOb.subscribe(moveOri);
        subs.mouseUpSub = mouseUpOb.subscribe(cancel);
    });
    return function () {
        for (var i_1 in subs) {
            subs[i_1] && subs[i_1].unsubscribe();
        }
    };
};
var slideEvents = function (node, withDrag, cb) {
    var x0, y0, x1, y1;
    return moveEvent(node, function (e) {
        x0 = e.x;
        y0 = e.y;
    }, function (e) {
        x1 = e.x;
        y1 = e.y;
    }, function () {
        var states = [], disY = y1 - y0, disX = x1 - x0;
        if (disY > baseDis)
            states.push('down');
        if (0 - disY > baseDis)
            states.push('up');
        if (disX > baseDis)
            states.push('right');
        if (0 - disX > baseDis)
            states.push('left');
        x0 = undefined;
        y0 = undefined;
        cb(states);
    }, withDrag, true);
};
var HandEvent = (function () {
    function HandEvent() {
        this.moveEvent = moveEvent;
        this.slideEvents = slideEvents;
    }
    return HandEvent;
}());
export { HandEvent };
//# sourceMappingURL=hand.js.map