import { Injectable } from '@angular/core';
import { getPos, resizePos, tooltipPos, transitionOrigin } from './pos';
var PositionService = (function () {
    function PositionService() {
        this._origin = transitionOrigin;
        this.getPos = getPos;
        this.resizePos = resizePos;
        this.tooltipPos = tooltipPos;
        this.posToRel = function (node) {
            var position = node.style.position || window.getComputedStyle(node, null).position;
            if (!position.match(/relative|absolute|flex/))
                node.style.position = 'relative';
        };
        this.moveAnimate = function (params, cb, end) {
            var x1 = params.x1, x0 = params.x0, t = params.t || 300, vt = params.vt || 10, timing = params.timing;
            var runFn = function (s, isOut, cbFn, endFn) {
                var pt = t / vt, a = s * 2 / (pt * pt), passT = 0;
                if (s == 0)
                    return;
                var getS = isOut ? function () { return a * pt * passT - a * passT * passT * 0.5; } : function () { return a * passT * passT * 0.5; };
                var moveInterval = setInterval(function () {
                    passT++;
                    cbFn(getS());
                    if (passT >= pt) {
                        clearInterval(moveInterval);
                        endFn && endFn();
                    }
                }, vt);
            };
            if (timing == 'out') {
                runFn(x1 - x0, true, cb, end);
            }
            else if (timing == 'in') {
                runFn(x1 - x0, false, cb, end);
            }
            else {
                var midX_1 = (x1 - x0) / 2;
                t *= 0.5;
                runFn(midX_1, false, cb, function () {
                    runFn(midX_1, true, function (n) { return cb(n + midX_1); }, end);
                });
            }
        };
    }
    PositionService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    PositionService.ctorParameters = function () { return []; };
    return PositionService;
}());
export { PositionService };
//# sourceMappingURL=pos.service.js.map